Package io.github.jdbcx

# Enum QueryMode

java.lang.Object
java.lang.Enum<QueryMode>
io.github.jdbcx.QueryMode

All Implemented Interfaces:
  `Serializable`, `Comparable<QueryMode>`, `java.lang.constant.Constable`

public enum QueryMode extends Enum<QueryMode>

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`ASYNC`
Executes a query asynchronously.
`DIRECT`
Executes a query immediately and waits the result.
`MUTATION`
Executes a mutation immediately and waits for the result.
`REDIRECT`
Submits a query and gets redirected to retrieve the results.
`SUBMIT`
Submits a query for later execution.

## Method Summary

Modifier and Type
Method
Description
`char`
`code()`
Gets a single character code representing the query mode.
`static QueryMode`
`fromCode(char code)`
Gets query mode based on the given code.
`static QueryMode`
`fromCode(char code, QueryMode defaultMode)`
Gets query mode based on the given code.
`static QueryMode`
`fromPath(String path)`
Gets query mode based on given path.
`static QueryMode`
`fromPath(String path, QueryMode defaultMode)`
Gets query mode based on given path.
`static QueryMode`
`of(String str)`
Gets query mode based on given string, which could be a single character `code`, `path` or `name`.
`String`
`path()`
Gets semantic relative path used in constructing the query URL.
`static QueryMode`
`valueOf(String name)`
Returns the enum constant of this type with the specified name.
`static QueryMode[]`
`values()`
Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### SUBMIT

public static final QueryMode SUBMIT
Submits a query for later execution.

### REDIRECT

public static final QueryMode REDIRECT
Submits a query and gets redirected to retrieve the results.

### ASYNC

public static final QueryMode ASYNC
Executes a query asynchronously.

### DIRECT

public static final QueryMode DIRECT
Executes a query immediately and waits the result.

### MUTATION

public static final QueryMode MUTATION
Executes a mutation immediately and waits for the result.

## Method Details

### values

public static QueryMode[] values()
Returns an array containing the constants of this enum type, in the order they are declared.

Returns:
  an array containing the constants of this enum type, in the order they are declared

### valueOf

public static QueryMode valueOf(String name)
Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null

### code

public char code()
Gets a single character code representing the query mode.

Returns:
  single character code

### path

public String path()
Gets semantic relative path used in constructing the query URL.

Returns:
  non-empty semantic relative path

### fromPath

public static QueryMode fromPath(String path)
Gets query mode based on given path.

Parameters:
  `path` - path
Returns:
  non-null query mode, defaults to `SUBMIT`

### fromPath

public static QueryMode fromPath(String path, QueryMode defaultMode)
Gets query mode based on given path.

Parameters:
  `path` - path
  `defaultMode` - default mode
Returns:
  query mode

### fromCode

public static QueryMode fromCode(char code)
Gets query mode based on the given code.

Parameters:
  `code` - code
Returns:
  non-null query mode, defaults to `SUBMIT`

### fromCode

public static QueryMode fromCode(char code, QueryMode defaultMode)
Gets query mode based on the given code.

Parameters:
  `code` - code
  `defaultMode` - default mode
Returns:
  query mode

### of

public static QueryMode of(String str)
Gets query mode based on given string, which could be a single character `code`, `path` or `name`.

Parameters:
  `str` - single character, path or name
Returns:
  non-null query mode, defaults to `SUBMIT`